﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO.Ports;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
	class SerialPortReader
	{
		private SerialPort serialPort;
		private const int TimeOut = 2000;

		public SerialPortReader()
		{
            serialPort = new SerialPort();
            serialPort.BaudRate = 19200;
            serialPort.PortName = "COM1";
            serialPort.Parity = Parity.None;
            serialPort.DataBits = 8;
			serialPort.ReadTimeout = TimeOut;
			serialPort.WriteTimeout = TimeOut;
			try
            {
                serialPort.Open();
                serialPort.DataReceived += new SerialDataReceivedEventHandler(serialPort_DataReceived);
                Console.WriteLine("\t\t\t== CONNECTED [COM1] ==");
            }
            catch (Exception)
            {
                Console.WriteLine("\t\t\t== CAN'T OPEN [COM1] ==");
            }

		}
        public SerialPortReader(string portName , int baudRate)
        {
            serialPort = new SerialPort();
            serialPort.BaudRate = baudRate;
            serialPort.PortName = portName;
			serialPort.Parity = Parity.None;
            serialPort.DataBits = 8;
            serialPort.ReadTimeout = TimeOut;
            serialPort.WriteTimeout = TimeOut;
            try
            {
                serialPort.Open();
                Console.WriteLine("\t\t\t== CONNECTED [" + portName+ "] ==");
                serialPort.DataReceived += new SerialDataReceivedEventHandler(serialPort_DataReceived);
            }
            catch (Exception)
            {
				MessageBox.Show("\t\t\t== CAN'T OPEN [" + portName + "] ==");
                Console.WriteLine("\t\t\t== CAN'T OPEN [" + portName + "] ==");
            }
            // DataBase initialisation
        }
        public void serialPort_DataReceived(object sender, SerialDataReceivedEventArgs e)
        {
            char RX;
			int start_data = 0;
			char[] data = new char[2];
			int stop_data = 1;
			int input_counter = -1;
			char[] buffer = new char[1];
            try {
                int btsToRead=  0;
                while ((btsToRead = serialPort.BytesToRead) > 0)
                {
					serialPort.Read(buffer, 0, 1);
					RX = buffer[0];
					input_counter++;
					if ((RX == '[') && (stop_data == 1))
					{
						start_data = 1;
						stop_data = 0;
						input_counter = 0;
						Console.WriteLine("=Start=");
					}
					else
					if (RX == ']' && input_counter == 2)
					{
						start_data = 0;
						stop_data = 1;
						input_counter = -1;
						Console.WriteLine("octet1 " + data[0] + "\n octet2 " + data[1]);
					}
					else
					if (start_data == 1 && stop_data == 0 && input_counter >=0  && input_counter < 2)
					{
						data[input_counter] = RX;
						input_counter++;
						Console.WriteLine("=Stop=");
					}
					else
					{
						Console.WriteLine("!!!Nu se respecta formatul datelor!!!");
					}
                }
            }
            catch(TimeoutException){
                Console.WriteLine("***********[ ! TimeOut ]*****************");
            }
        }
        public void Close()
        {
            serialPort.Close();
        }

	}
}
