﻿using System;
using System.Collections.Generic;
using System.Text;
using OpenAL;
using Sample.FileLoader;

namespace Sample
{
	class SoundGenerator
	{
		public const int NUM_BUFFERS = 8;
		public const int NUM_SOURCES = 8;
		public const int DO	= 0;
		public const int RE	= 1;
		public const int MI	= 2;
		public const int FA	= 3;
		public const int SOL= 4;
		public const int LA	= 5;
		public const int SI	= 6;
		public const int DO2= 7;


		int[] FBuffer = new int[NUM_BUFFERS];
        int[] FSource = new int[NUM_SOURCES];

		private ContextAL FContext;
		public SoundGenerator()
		{
			int[] Buf = new int[NUM_BUFFERS];

			FContext = new ContextAL();

			//Die WAV-Datei laden
			FBuffer[0] = FileWAV.LoadFromFile("note\\do.wav");
			FBuffer[1] = FileWAV.LoadFromFile("note\\re.wav");
			FBuffer[2] = FileWAV.LoadFromFile("note\\mi.wav");
			FBuffer[3] = FileWAV.LoadFromFile("note\\fa.wav");
			FBuffer[4] = FileWAV.LoadFromFile("note\\sol.wav");
			FBuffer[5] = FileWAV.LoadFromFile("note\\la.wav");
			FBuffer[6] = FileWAV.LoadFromFile("note\\si.wav");
			FBuffer[7] = FileWAV.LoadFromFile("note\\do2.wav");

			al.GenSources(NUM_BUFFERS, Buf);

			for (int i = 0; i < NUM_SOURCES; i++)
			{
				FSource[i] = Buf[i];

				al.Sourcei(FSource[i], al.BUFFER, FBuffer[i]);
				al.Sourcef(FSource[i], al.PITCH, 1.0f);
				al.Sourcef(FSource[i], al.GAIN, 1.0f);
				al.Sourcefv(FSource[i], al.POSITION, new float[3] { 0, 0, 0 });
				al.Sourcefv(FSource[i], al.VELOCITY, new float[3] { 0, 0, 0 });

				al.Listenerfv(al.POSITION, new float[3] { 0, 0, 0 });
				al.Listenerfv(al.VELOCITY, new float[3] { 0, 0, 0 });
				al.Listenerfv(al.ORIENTATION, new float[6] { 0, 0, -1, 0, 1, 0 });
			}
		}
		public void PlayNote(int note)
		{
			al.SourcePlay(FSource[note]);
		}
		public void PlayNotes(Notes notes)
		{
			for (int i = 0; i < Notes.NUM_NOTES; i++)
			{
				if (notes.getNote(i) == 1)
					al.SourcePlay(FSource[i]);
			}
		}
		public void DeleteSources()
		{
			for (int i = 0; i < NUM_SOURCES; i++)
				al.DeleteSources(1, new int[1] { FSource[i] });
			for (int i = 0; i < NUM_SOURCES; i++)
				al.DeleteBuffers(1, new int[1] { FBuffer[i] });

			FContext.Dispose();
		}

	}
}
