#define F_CPU 16000000UL
#include <avr/io.h>
#include <util/delay.h>
#include <inttypes.h>

//This function is used to initialize the USART
//at a given UBRR value
void USARTWriteChar(char data)
{
   //Wait untill the transmitter is ready
   while(!(UCSRA & (1<<UDRE)))
   {
      //Do nothing
   }
   //Now write the data to USART buffer
   UDR=data;
}

void USARTInit(uint16_t ubrr_value)
{
   //Set Baud rate
   UBRRL = ubrr_value;
   UBRRH = (ubrr_value>>8);
   /*Set Frame Format
   >> Asynchronous mode
   >> No Parity
   >> 1 StopBit
   >> char size 8
   */
   UCSRC=(1<<URSEL)|(3<<UCSZ0);
   //Enable The receiver and transmitter
   UCSRB=(1<<RXEN)|(1<<TXEN);
}
void ButtonsInit()
{
    // set all pins on PORTB for input
    DDRA = 0x00;
	PORTA = 0xFF;       //enable all pull-ups	
    // set all pins on PORTC for input
    DDRC = 0x00;
	PORTC = 0xFF;       //enable all pull-ups	

}
int main(void)
{
   char data;
   /*First Initialize the USART with baud rate = 19200bps
   UBRR value = 51
   */
   USARTInit(51);    //UBRR = 51
	ButtonsInit();
	_delay_ms(1000);
	char keys_portA, keys_portC;
    while (1) 
    {
		_delay_ms(500);
		keys_portA = PINA;
		keys_portC = PINC;
		USARTWriteChar('[');
		USARTWriteChar(keys_portA);
		USARTWriteChar(keys_portC);
		USARTWriteChar(']');
		
    }
   return 0;
}
